unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls,
  mTGeoObj, mTGPoint, mTGLine, mTGCircle, mTGQuadrat, MathEdit;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    PaintBox1: TPaintBox;
    Label1: TLabel;
    BtnPointCreate: TButton;
    Label2: TLabel;
    BtnLineCreate: TButton;
    Label3: TLabel;
    BtnCircleCreate: TButton;
    Label4: TLabel;
    BtnQuadCreate: TButton;
    IntEdit1: TIntEdit;
    IntEdit2: TIntEdit;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    IntEdit3: TIntEdit;
    Label8: TLabel;
    IntEdit4: TIntEdit;
    Label9: TLabel;
    IntEdit5: TIntEdit;
    Label10: TLabel;
    IntEdit6: TIntEdit;
    Label11: TLabel;
    IntEdit7: TIntEdit;
    Label12: TLabel;
    IntEdit8: TIntEdit;
    Label13: TLabel;
    IntEdit9: TIntEdit;
    Label14: TLabel;
    IntEdit10: TIntEdit;
    Label15: TLabel;
    IntEdit11: TIntEdit;
    Label16: TLabel;
    IntEdit12: TIntEdit;
    Edit1: TEdit;
    Label17: TLabel;
    procedure BtnPointCreateClick(Sender: TObject);
    procedure BtnLineCreateClick(Sender: TObject);
    procedure BtnCircleCreateClick(Sender: TObject);
    procedure BtnQuadCreateClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormPaint(Sender: TObject);
    procedure PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PaintBox1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private-Deklarationen }
    GeoListe     : TList;
    SelectedObj  : TGeoObj;
    isDragging   : Boolean;
    LastMousePos : TPoint;
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

{========== Lebenslauf des Formulars ===========================}

procedure TForm1.FormCreate(Sender: TObject);
  begin
  GeoListe   := TList.Create;
  isDragging := False;
  end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
  var i: Integer;
  begin
  For i := GeoListe.Count - 1 downto 0 do   // Erst alle gespeicherten
    TGeoObj(GeoListe.Items[i]).Free;        // Objekte entsorgen,
  GeoListe.Free;                            // dann die Liste selbst!
  end;

procedure TForm1.FormPaint(Sender: TObject);
  var i : Integer;
  begin
  For i := 0 to GeoListe.Count - 1 do
    TGeoObj(Geoliste.Items[i]).DrawIt(Paintbox1.Canvas);
  end;

{=========== Knpfe zum Objekte-Erzeugen ==========================}

procedure TForm1.BtnPointCreateClick(Sender: TObject);
  begin
  GeoListe.Add(TGPoint.Create(IntEdit1.Value, IntEdit2.Value, clBlack));
  Invalidate;
  end;

procedure TForm1.BtnLineCreateClick(Sender: TObject);
  begin
  GeoListe.Add(TGLine.Create(IntEdit3.Value, IntEdit4.Value,
                             IntEdit5.Value, IntEdit6.Value, clBlue));
  Invalidate;
  end;

procedure TForm1.BtnCircleCreateClick(Sender: TObject);
  begin
  GeoListe.Add(TGCircle.Create(IntEdit7.Value, IntEdit8.Value,
                               IntEdit9.Value, clRed));
  Invalidate;
  end;

procedure TForm1.BtnQuadCreateClick(Sender: TObject);
  begin
  GeoListe.Add(TGQuadrat.Create(IntEdit11.Value, IntEdit12.Value,
                                IntEdit10.Value, clBlue));
  Invalidate;
  end;

{======== Maus-Methoden der Paintbox ============================}

procedure TForm1.PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
  begin
  If (SelectedObj <> Nil) and (Button = mbLeft) then begin
    isDragging := True;
    LastMousePos.x := X;
    LastMousePos.y := Y;
    end;
  end;

procedure TForm1.PaintBox1MouseMove(Sender: TObject; Shift: TShiftState;
                                    X, Y: Integer);
  var d, dmin : Double;
      dx, dy,
      n, i    : Integer;
  begin
  If isDragging then begin
    dx := X - LastMousePos.x;
    dy := Y - LastMousePos.y;
    SelectedObj.Move(dx, dy, PaintBox1.Canvas);
    LastMousePos.x := X;
    LastMousePos.y := Y;
    end
  else begin
    dmin := 10000;
    n    := -1;
    For i := 0 to GeoListe.Count - 1 do begin
      d := TGeoObj(GeoListe.Items[i]).Dist(X, Y);
      If d < dmin then begin
        dmin := d;
        n    := i;
        end;
      end;
    If dmin < 5 then begin
      PaintBox1.Cursor := crHandPoint;
      SelectedObj := GeoListe.Items[n];
      Edit1.Text  := SelectedObj.Info;
      end
    else begin
      PaintBox1.Cursor := crDefault;
      SelectedObj := Nil;
      Edit1.Text  := '';
      end;
    end;
  end;

procedure TForm1.PaintBox1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
  begin
  isDragging  := False;
  SelectedObj := Nil;
  PaintBox1.Cursor := crDefault;
  Invalidate;
  end;

end.
